import { Container } from 'inversify';
import 'reflect-metadata';
import { IMapService } from '../map/IMapService';
import { IControl, IControlCorners, IControlService, IControlServiceCfg } from './IControlService';
export default class ControlService implements IControlService {
    container: HTMLElement;
    controlCorners: IControlCorners;
    controlContainer: HTMLElement;
    scene: Container;
    mapsService: IMapService;
    private controls;
    private unAddControls;
    init(cfg: IControlServiceCfg, sceneContainer: Container): void;
    addControl(ctr: IControl, sceneContainer: Container): void;
    getControlByName(name: string | number): IControl | undefined;
    removeControl(ctr: IControl): this;
    addControls(): void;
    destroy(): void;
    private initControlPos;
    private clearControlPos;
}
