import EventEmitter from 'eventemitter3';
import 'reflect-metadata';
import { IInteractionService } from './IInteractionService';
/**
 * 由于目前 L7 与地图结合的方案为双 canvas 而非共享 WebGL Context，事件监听注册在地图底图上。
 * 除此之外，后续如果支持非地图场景，事件监听就需要注册在 L7 canvas 上。
 */
export default class InteractionService extends EventEmitter implements IInteractionService {
    indragging: boolean;
    private readonly mapService;
    private hammertime;
    private lastClickTime;
    private lastClickXY;
    private clickTimer;
    private $containter;
    init(): void;
    destroy(): void;
    triggerHover({ x, y }: {
        x: number;
        y: number;
    }): void;
    triggerSelect(id: number): void;
    triggerActive(id: number): void;
    handleMiniEvent(e: any): void;
    private addEventListenerOnMap;
    private removeEventListenerOnMap;
    private onDrag;
    private onHammer;
    private onTouch;
    private interactionEvent;
    private onHover;
    private isDoubleTap;
}
