import 'reflect-metadata';
import { IInteractionTarget } from '../interaction/IInteractionService';
import { ILayer } from '../layer/ILayerService';
import { ILngLat } from '../map/IMapService';
import { IPickingService } from './IPickingService';
export default class PickingService implements IPickingService {
    pickedColors: Uint8Array | undefined;
    pickedTileLayers: ILayer[];
    private readonly mapService;
    private rendererService;
    private readonly configService;
    private interactionService;
    private layerService;
    private pickingFBO;
    private width;
    private height;
    private alreadyInPicking;
    private pickBufferScale;
    init(id: string): void;
    boxPickLayer(layer: ILayer, box: [number, number, number, number], cb: (...args: any[]) => void): Promise<any>;
    pickBox(layer: ILayer, box: [number, number, number, number]): any[];
    handleCursor(layer: ILayer, type: string): void;
    destroy(): void;
    pickFromPickingFBO: (layer: ILayer, { x, y, lngLat, type, target }: IInteractionTarget) => boolean;
    private getContainerSize;
    private pickingAllLayer;
    private isPickingAllLayer;
    private resizePickingFBO;
    private pickingLayers;
    triggerHoverOnLayer(layer: ILayer, target: {
        x: number;
        y: number;
        type: string;
        lngLat: ILngLat;
        feature: unknown;
        featureId: number | null;
    }): void;
}
