import 'reflect-metadata';
import { ICameraService } from '../../camera/ICameraService';
import { IInteractionService } from '../../interaction/IInteractionService';
import { ILayer, ILayerService } from '../../layer/ILayerService';
import { IMapService } from '../../map/IMapService';
import { IShaderModuleService } from '../../shader/IShaderModuleService';
import { IPass, PassType } from '../IMultiPassRenderer';
import { IRendererService } from '../IRendererService';
/**
 * 常规 Pass 基类
 */
export default class BaseNormalPass<InitializationOptions = {}> implements IPass<InitializationOptions> {
    protected shaderModuleService: IShaderModuleService;
    protected rendererService: IRendererService;
    protected cameraService: ICameraService;
    protected mapService: IMapService;
    protected interactionService: IInteractionService;
    protected layerService: ILayerService;
    protected config: Partial<InitializationOptions> | undefined;
    getName(): string;
    getType(): PassType;
    init(layer: ILayer, config?: Partial<InitializationOptions>): void;
    render(layer: ILayer): void;
}
