import 'reflect-metadata';
import { IUniform } from '../../IUniform';
import BasePostProcessingPass from '../BasePostProcessingPass';
export interface IBloomPassConfig {
    bloomBaseRadio: number;
    bloomRadius: number;
    bloomIntensity: number;
}
export default class BloomPass extends BasePostProcessingPass<IBloomPassConfig> {
    protected setupShaders(): {
        vs: string;
        fs: string;
        uniforms: {
            u_ViewportSize: number[];
        };
    };
    protected convertOptionsToUniforms(options: Partial<IBloomPassConfig>): {
        [uniformName: string]: IUniform;
    } | void;
}
