import 'reflect-metadata';
import { IUniform } from '../../IUniform';
import BasePostProcessingPass from '../BasePostProcessingPass';
export interface IBlurHPassConfig {
    blurRadius: number;
}
export default class BlurHPass extends BasePostProcessingPass<IBlurHPassConfig> {
    protected setupShaders(): {
        vs: string;
        fs: string;
        uniforms: {
            u_ViewportSize: number[];
        };
    };
    protected convertOptionsToUniforms(options: Partial<IBlurHPassConfig>): {
        [uniformName: string]: IUniform;
    } | void;
}
