interface IDistanceScales {
    pixelsPerMeter: [number, number, number];
    metersPerPixel: [number, number, number];
    pixelsPerDegree: [number, number, number];
    degreesPerPixel: [number, number, number];
    pixelsPerDegree2: [number, number, number];
    pixelsPerMeter2: [number, number, number];
}
/**
 * Calculate distance scales in meters around current lat/lon, both for
 * degrees and pixels.
 * In mercator projection mode, the distance scales vary significantly
 * with latitude.
 */
export declare function getDistanceScales({ latitude, zoom, scale, highPrecision, flipY, }: Partial<{
    latitude: number;
    zoom: number;
    scale: number | undefined;
    highPrecision: boolean;
    flipY: boolean;
}>): IDistanceScales;
export {};
