"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createVec3 = createVec3;
exports.getAngle = getAngle;

var _glMatrix = require("gl-matrix");

function getAngle(angle) {
  if (angle === undefined) {
    return 0;
  } else if (angle > 360 || angle < -360) {
    return angle % 360;
  }

  return angle;
}

function createVec3(x, y, z) {
  // @ts-ignore
  if (x instanceof _glMatrix.vec3) {
    return _glMatrix.vec3.clone(x); // @ts-ignore
  } else if (x instanceof _glMatrix.vec4) {
    x = x;
    return _glMatrix.vec3.fromValues(x[0], x[1], x[2]);
  } else {
    return _glMatrix.vec3.fromValues(x, y, z);
  }
}